from cell_adt import *

def norMap(x,dim):
    return ((x-1)%dim)+1

class Map():                       
    def __init__(self,d,N):
        self._d = d
        self._N = N
        self._M = {}

    def dimMap(self):
        return self._d

    def NumSpeciesMap(self):
        return self._N    

    def atrMap(self,i,j,c): 
        assert 1<=i<=self.dimMap() and 1<=j<=self.dimMap() and c.num_espCel()==self.NumSpeciesMap()
        if c.totCel()==0:
            self._M.pop((i,j),None)
        else:
            self._M[(i,j)]=c

    def celMap(self,i,j): 
        assert 1<=i<= self.dimMap() and 1<=j<= self.dimMap()
        return self._M.get((i,j),Cell(self.NumSpeciesMap()))

    def freeMap(self,i,j):
        return self.celMap(i,j).freeSpace()

    def posNeiMap(self,i,j,r):
        assert 1<=i<=self.dimMap() and 1<=j<=self.dimMap()
        return [(norMap(a+i,self.dimMap()),norMap(b+j,self.dimMap())) for a in range(-r,r+1) for b in range (-r,r+1)]

#    def neiMap(self,i,j,r):
#        lcels  = [self._M.get(pos,Cell(self.NumSpeciesMap())) for pos in self.posNeiMap(i,j,r)]
#        mprobs = [c.listCel() for c in lcels]
#        mprobs = map(list, zip(*mprobs)) 
#        return list(map(sum,mprobs))

    def neiMap(self,i,j,r):
        lcels  = [self.celMap(a,b).listCel() for (a,b) in self.posNeiMap(i,j,r)]
        return [sum(map(lambda w:w[s],lcels)) for s in range(self.NumSpeciesMap())]

    def list_posMap(self): 
        return [[(pos,self._M[pos].valCel(s+1)) for pos in self._M.keys()] for s in range(self.NumSpeciesMap())]

